#include <bits/stdc++.h>
using namespace std;

const long long INF = 1LL << 40;

int main() {
    int N, T;
    long long K;
    cin >> N >> K >> T;
    vector<long long> A(N);
    for (auto &a : A) cin >> a;

    for (int i=0; i<N; ++i) A[i] -= K*i;

    vector<int> best(N, 1);
    for (int n=1; n<N; ++n) for (int i=0; i<n; ++i) if (A[n] <= A[i]) best[n] = max( best[n], best[i]+1 );

    int longest = *max_element(best.begin(),best.end());
    cout << (N - longest) << endl;
    if (T == 1) return 0;

    vector<bool> keep(N, false);
    int where = 0;
    while (best[where] != longest) ++where;
    while (true) {
        keep[where] = true;
        if (best[where] == 1) break;
        for (int i=0; i<where; ++i) if (A[where] <= A[i] && best[where] == best[i]+1) { where = i; break; }
    }
    // for (bool x : keep) cout << x << " "; cout << endl;
    
    for (int i=0; i<N; ++i) A[i] += K*i;

    int start = 0;
    while (!keep[start]) ++start;
    for (int i=0; i<start; ++i) A[i] = 1000000000;
    for (int i=start; i<N; ++i) if (!keep[i]) A[i] = min( A[i-1]+K, 1000000000LL );
    for (int i=0; i<N; ++i) cout << A[i] << (i+1==N ? "\n" : " ");

}
